

# Class: CoordinatorWrapper

This class includes all the functionality related to filling or cancelling orders through
the 0x V2 Coordinator extension contract.


##   Constructors



\+ **new CoordinatorWrapper**(`provider`: `SupportedProvider`, `networkId`: number, `address?`: undefined | string, `exchangeAddress?`: undefined | string, `registryAddress?`: undefined | string): *[CoordinatorWrapper](#class-coordinatorwrapper)*

*Defined in [coordinator_wrapper.ts:43](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L43)*

Instantiate CoordinatorWrapper

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`provider` | `SupportedProvider` | - |
`networkId` | number | Desired networkId. |
`address?` | undefined \| string | The address of the Coordinator contract. If undefined, will default to the known address corresponding to the networkId. |
`exchangeAddress?` | undefined \| string | The address of the Exchange contract. If undefined, will default to the known address corresponding to the networkId. |
`registryAddress?` | undefined \| string | The address of the CoordinatorRegistry contract. If undefined, will default to the known address corresponding to the networkId.  |

**Returns:** *[CoordinatorWrapper](#class-coordinatorwrapper)*

## Properties

###  abi

• **abi**: *`ContractAbi`* =  Coordinator.compilerOutput.abi

*Defined in [coordinator_wrapper.ts:34](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L34)*

___

###  address

• **address**: *string*

*Defined in [coordinator_wrapper.ts:36](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L36)*

___

###  exchangeAddress

• **exchangeAddress**: *string*

*Defined in [coordinator_wrapper.ts:37](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L37)*

___

###  networkId

• **networkId**: *number*

*Defined in [coordinator_wrapper.ts:35](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L35)*

___

###  registryAddress

• **registryAddress**: *string*

*Defined in [coordinator_wrapper.ts:38](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L38)*

## Methods

###  assertValidCoordinatorApprovalsOrThrowAsync

▸ **assertValidCoordinatorApprovalsOrThrowAsync**(`transaction`: `ZeroExTransaction`, `txOrigin`: string, `transactionSignature`: string, `approvalExpirationTimeSeconds`: `BigNumber`[], `approvalSignatures`: string[]): *`Promise<void>`*

*Defined in [coordinator_wrapper.ts:637](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L637)*

Validates that the 0x transaction has been approved by all of the feeRecipients that correspond to each order in the transaction's Exchange calldata.
Throws an error if the transaction approvals are not valid. Will not detect failures that would occur when the transaction is executed on the Exchange contract.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transaction` | `ZeroExTransaction` | 0x transaction containing salt, signerAddress, and data. |
`txOrigin` | string | Required signer of Ethereum transaction calling this function. |
`transactionSignature` | string | Proof that the transaction has been signed by the signer. |
`approvalExpirationTimeSeconds` | `BigNumber`[] | Array of expiration times in seconds for which each corresponding approval signature expires. |
`approvalSignatures` | string[] | Array of signatures that correspond to the feeRecipients of each order in the transaction's Exchange calldata.  |

**Returns:** *`Promise<void>`*

___

###  batchFillOrKillOrdersAsync

▸ **batchFillOrKillOrdersAsync**(`signedOrders`: `SignedOrder`[], `takerAssetFillAmounts`: `BigNumber`[], `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:273](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L273)*

Batch version of fillOrKillOrderAsync. Executes multiple fills atomically in a single transaction.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrders` | `SignedOrder`[] | - | An array of signed orders to fill. |
`takerAssetFillAmounts` | `BigNumber`[] | - | The amounts of the orders (in taker asset baseUnits) that you wish to fill. |
`takerAddress` | string | - | The user Ethereum address who would like to fill these orders. Must be available via the supplied                                Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  batchFillOrdersAsync

▸ **batchFillOrdersAsync**(`signedOrders`: `SignedOrder`[], `takerAssetFillAmounts`: `BigNumber`[], `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:203](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L203)*

Batch version of fillOrderAsync. Executes multiple fills atomically in a single transaction.
Under-the-hood, this method uses the `feeRecipientAddress`s of the orders to looks up the coordinator server endpoints
registered in the coordinator registry contract. It requests a signature from each coordinator server before
submitting the orders and signatures as a 0x transaction to the coordinator extension contract, which validates the
signatures and then fills the order through the Exchange contract.
If any `feeRecipientAddress` in the batch is not registered to a coordinator server, the whole batch fails.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrders` | `SignedOrder`[] | - | An array of signed orders to fill. |
`takerAssetFillAmounts` | `BigNumber`[] | - | The amounts of the orders (in taker asset baseUnits) that you wish to fill. |
`takerAddress` | string | - | The user Ethereum address who would like to fill these orders. Must be available via the supplied                                Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  batchFillOrdersNoThrowAsync

▸ **batchFillOrdersNoThrowAsync**(`signedOrders`: `SignedOrder`[], `takerAssetFillAmounts`: `BigNumber`[], `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:238](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L238)*

No throw version of batchFillOrdersAsync

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrders` | `SignedOrder`[] | - | An array of signed orders to fill. |
`takerAssetFillAmounts` | `BigNumber`[] | - | The amounts of the orders (in taker asset baseUnits) that you wish to fill. |
`takerAddress` | string | - | The user Ethereum address who would like to fill these orders. Must be available via the supplied                                Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  batchHardCancelOrdersAsync

▸ **batchHardCancelOrdersAsync**(`orders`: `SignedOrder`[], `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:568](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L568)*

Batch version of hardCancelOrderAsync. Cancels orders on-chain by submitting an Ethereum transaction.
Executes multiple cancels atomically in a single transaction.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`orders` | `SignedOrder`[] | - | An array of orders to cancel. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  batchSoftCancelOrdersAsync

▸ **batchSoftCancelOrdersAsync**(`orders`: `SignedOrder`[]): *`Promise<CoordinatorServerCancellationResponse[]>`*

*Defined in [coordinator_wrapper.ts:482](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L482)*

Batch version of softCancelOrderAsync. Requests multiple soft cancels

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `SignedOrder`[] | An array of orders to cancel. |

**Returns:** *`Promise<CoordinatorServerCancellationResponse[]>`*

CoordinatorServerCancellationResponse. See [Cancellation Response](https://github.com/0xProject/0x-protocol-specification/blob/master/v2/coordinator-specification.md#response).

___

###  fillOrKillOrderAsync

▸ **fillOrKillOrderAsync**(`signedOrder`: `SignedOrder`, `takerAssetFillAmount`: `BigNumber`, `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:166](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L166)*

Attempts to fill a specific amount of an order. If the entire amount specified cannot be filled,
the fill order is abandoned.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrder` | `SignedOrder` | - | An object that conforms to the SignedOrder interface. |
`takerAssetFillAmount` | `BigNumber` | - | The amount of the order (in taker asset baseUnits) that you wish to fill. |
`takerAddress` | string | - | The user Ethereum address who would like to fill this order. Must be available via the supplied                               Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  fillOrderAsync

▸ **fillOrderAsync**(`signedOrder`: `SignedOrder`, `takerAssetFillAmount`: `BigNumber`, `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:101](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L101)*

Fills a signed order with an amount denominated in baseUnits of the taker asset. Under-the-hood, this
method uses the `feeRecipientAddress` of the order to look up the coordinator server endpoint registered in the
coordinator registry contract. It requests a signature from that coordinator server before
submitting the order and signature as a 0x transaction to the coordinator extension contract. The coordinator extension
contract validates signatures and then fills the order via the Exchange contract.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrder` | `SignedOrder` | - | An object that conforms to the SignedOrder interface. |
`takerAssetFillAmount` | `BigNumber` | - | The amount of the order (in taker asset baseUnits) that you wish to fill. |
`takerAddress` | string | - | The user Ethereum address who would like to fill this order. Must be available via the supplied                                Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  fillOrderNoThrowAsync

▸ **fillOrderNoThrowAsync**(`signedOrder`: `SignedOrder`, `takerAssetFillAmount`: `BigNumber`, `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:133](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L133)*

No-throw version of fillOrderAsync. This version will not throw if the fill fails. This allows the caller to save gas at the expense of not knowing the reason the fill failed.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrder` | `SignedOrder` | - | An object that conforms to the SignedOrder interface. |
`takerAssetFillAmount` | `BigNumber` | - | The amount of the order (in taker asset baseUnits) that you wish to fill. |
`takerAddress` | string | - | The user Ethereum address who would like to fill this order.                               Must be available via the supplied Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  getSignerAddressAsync

▸ **getSignerAddressAsync**(`hash`: string, `signature`: string): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:669](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L669)*

Recovers the address of a signer given a hash and signature.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`hash` | string | Any 32 byte hash. |
`signature` | string | Proof that the hash has been signed by signer. |

**Returns:** *`Promise<string>`*

Signer address.

___

###  hardCancelOrderAsync

▸ **hardCancelOrderAsync**(`order`: `Order` | `SignedOrder`, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:536](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L536)*

Cancels an order on-chain by submitting an Ethereum transaction.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`order` | `Order` \| `SignedOrder` | - | An object that conforms to the Order or SignedOrder interface. The order you would like to cancel. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  hardCancelOrdersUpToAsync

▸ **hardCancelOrdersUpToAsync**(`targetOrderEpoch`: `BigNumber`, `senderAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:603](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L603)*

Cancels orders on-chain by submitting an Ethereum transaction.
Cancels all orders created by makerAddress with a salt less than or equal to the targetOrderEpoch
and senderAddress equal to coordinator extension contract address.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`targetOrderEpoch` | `BigNumber` | - | Target order epoch. |
`senderAddress` | string | - | Address that should send the transaction. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  marketBuyOrdersAsync

▸ **marketBuyOrdersAsync**(`signedOrders`: `SignedOrder`[], `makerAssetFillAmount`: `BigNumber`, `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:313](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L313)*

Synchronously executes multiple calls to fillOrder until total amount of makerAsset is bought by taker.
Under-the-hood, this method uses the `feeRecipientAddress`s of the orders to looks up the coordinator server endpoints
registered in the coordinator registry contract. It requests a signature from each coordinator server before
submitting the orders and signatures as a 0x transaction to the coordinator extension contract, which validates the
signatures and then fills the order through the Exchange contract.
If any `feeRecipientAddress` in the batch is not registered to a coordinator server, the whole batch fails.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrders` | `SignedOrder`[] | - | An array of signed orders to fill. |
`makerAssetFillAmount` | `BigNumber` | - | Maker asset fill amount. |
`takerAddress` | string | - | The user Ethereum address who would like to fill these orders. Must be available via the supplied                               Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  marketBuyOrdersNoThrowAsync

▸ **marketBuyOrdersNoThrowAsync**(`signedOrders`: `SignedOrder`[], `makerAssetFillAmount`: `BigNumber`, `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:384](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L384)*

No throw version of marketBuyOrdersAsync

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrders` | `SignedOrder`[] | - | An array of signed orders to fill. |
`makerAssetFillAmount` | `BigNumber` | - | Maker asset fill amount. |
`takerAddress` | string | - | The user Ethereum address who would like to fill these orders. Must be available via the supplied                               Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  marketSellOrdersAsync

▸ **marketSellOrdersAsync**(`signedOrders`: `SignedOrder`[], `takerAssetFillAmount`: `BigNumber`, `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:351](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L351)*

Synchronously executes multiple calls to fillOrder until total amount of makerAsset is bought by taker.
Under-the-hood, this method uses the `feeRecipientAddress`s of the orders to looks up the coordinator server endpoints
registered in the coordinator registry contract. It requests a signature from each coordinator server before
submitting the orders and signatures as a 0x transaction to the coordinator extension contract, which validates the
signatures and then fills the order through the Exchange contract.
If any `feeRecipientAddress` in the batch is not registered to a coordinator server, the whole batch fails.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrders` | `SignedOrder`[] | - | An array of signed orders to fill. |
`takerAssetFillAmount` | `BigNumber` | - | Taker asset fill amount. |
`takerAddress` | string | - | The user Ethereum address who would like to fill these orders. Must be available via the supplied                               Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  marketSellOrdersNoThrowAsync

▸ **marketSellOrdersNoThrowAsync**(`signedOrders`: `SignedOrder`[], `takerAssetFillAmount`: `BigNumber`, `takerAddress`: string, `orderTransactionOpts`: [OrderTransactionOpts](#interface-ordertransactionopts)): *`Promise<string>`*

*Defined in [coordinator_wrapper.ts:417](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L417)*

No throw version of marketSellOrdersAsync

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`signedOrders` | `SignedOrder`[] | - | An array of signed orders to fill. |
`takerAssetFillAmount` | `BigNumber` | - | Taker asset fill amount. |
`takerAddress` | string | - | The user Ethereum address who would like to fill these orders. Must be available via the supplied                               Provider provided at instantiation. |
`orderTransactionOpts` | [OrderTransactionOpts](#interface-ordertransactionopts) |  { shouldValidate: true } | Optional arguments this method accepts. |

**Returns:** *`Promise<string>`*

Transaction hash.

___

###  softCancelOrderAsync

▸ **softCancelOrderAsync**(`order`: `Order` | `SignedOrder`): *`Promise<CoordinatorServerCancellationResponse>`*

*Defined in [coordinator_wrapper.ts:447](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/coordinator_wrapper.ts#L447)*

Soft cancel a given order.
Soft cancels are recorded only on coordinator operator servers and do not involve an Ethereum transaction.
See [soft cancels](https://github.com/0xProject/0x-protocol-specification/blob/master/v2/coordinator-specification.md#soft-cancels).

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | `Order` \| `SignedOrder` | An object that conforms to the Order or SignedOrder interface. The order you would like to cancel. |

**Returns:** *`Promise<CoordinatorServerCancellationResponse>`*

CoordinatorServerCancellationResponse. See [Cancellation Response](https://github.com/0xProject/0x-protocol-specification/blob/master/v2/coordinator-specification.md#response).

<hr />

# Class: IWalletContract


##   Constructors



\+ **new IWalletContract**(`address`: string, `supportedProvider`: `SupportedProvider`, `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object): *[IWalletContract](#class-iwalletcontract)*

*Overrides void*

*Defined in [generated-wrappers/i_wallet.ts:206](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L206)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`supportedProvider` | `SupportedProvider` |
`txDefaults?` | `Partial<TxData>` |
`logDecodeDependencies?` | undefined \| object |

**Returns:** *[IWalletContract](#class-iwalletcontract)*

## Properties

###  abi

• **abi**: *`ContractAbi`*





___

###  address

• **address**: *string*





___

Args

• **constructorArgs**: *any[]*





___

###  contractName

• **contractName**: *string*





## Methods

###  evmExecAsync

▸ **evmExecAsync**(`input`: `Buffer`): *`Promise<string>`*





**Parameters:**

Name | Type |
------ | ------ |
`input` | `Buffer` |

**Returns:** *`Promise<string>`*

___

### `Static` ABI

▸ **ABI**(): *`ContractAbi`*

*Defined in [generated-wrappers/i_wallet.ts:179](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L179)*

**Returns:** *`ContractAbi`*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: `ContractAbi`, `supportedProvider`: `SupportedProvider`, `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<IWalletContract>`*

*Defined in [generated-wrappers/i_wallet.ts:137](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L137)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | `ContractAbi` |
`supportedProvider` | `SupportedProvider` |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<IWalletContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: `SupportedProvider`, `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<IWalletContract>`*

*Defined in [generated-wrappers/i_wallet.ts:112](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L112)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | `SupportedProvider` |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<IWalletContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*





**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

## Object literals

###  isValidSignature

#### ▪ **isValidSignature**: *object*

*Defined in [generated-wrappers/i_wallet.ts:33](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L33)*

Verifies that a signature is valid.

####  callAsync

▸ **callAsync**(`hash`: string, `signature`: string, `callData`: `Partial<CallData>`, `defaultBlock?`: `BlockParam`): *`Promise<string>`*

*Defined in [generated-wrappers/i_wallet.ts:42](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L42)*

Sends a read-only call to the contract method. Returns the result that would happen if one were to send an
Ethereum transaction to this method, given the current state of the blockchain. Calls do not cost gas
since they don't modify state.

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`hash` | string | - | Message hash that is signed. |
`signature` | string | - | Proof of signing. |
`callData` | `Partial<CallData>` |  {} | - |
`defaultBlock?` | `BlockParam` | - | - |

**Returns:** *`Promise<string>`*

Magic bytes4 value if the signature is valid.         Magic value is bytes4(keccak256(&quot;isValidWalletSignature(bytes32,address,bytes)&quot;))

####  getABIDecodedReturnData

▸ **getABIDecodedReturnData**(`returnData`: string): *string*

*Defined in [generated-wrappers/i_wallet.ts:104](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L104)*

**Parameters:**

Name | Type |
------ | ------ |
`returnData` | string |

**Returns:** *string*

####  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**(`callData`: string): *string*

*Defined in [generated-wrappers/i_wallet.ts:97](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L97)*

**Parameters:**

Name | Type |
------ | ------ |
`callData` | string |

**Returns:** *string*

####  getABIEncodedTransactionData

▸ **getABIEncodedTransactionData**(`hash`: string, `signature`: string): *string*

*Defined in [generated-wrappers/i_wallet.ts:87](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/generated-wrappers/i_wallet.ts#L87)*

Returns the ABI encoded transaction data needed to send an Ethereum transaction calling this method. Before
sending the Ethereum tx, this encoded tx data can first be sent to a separate signing service or can be used
to create a 0x transaction (see protocol spec for more details).

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`hash` | string | Message hash that is signed. |
`signature` | string | Proof of signing.  |

**Returns:** *string*

<hr />

# Class: CoordinatorServerError


##   Constructors



\+ **new CoordinatorServerError**(`message`: [CoordinatorServerErrorMsg](#enumeration-coordinatorservererrormsg), `approvedOrders`: `SignedOrder`[], `cancellations`: [CoordinatorServerCancellationResponse](#interface-coordinatorservercancellationresponse)[], `errors`: [CoordinatorServerResponse](#interface-coordinatorserverresponse)[]): *[CoordinatorServerError](#class-coordinatorservererror)*

*Defined in [utils/coordinator_server_types.ts:43](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L43)*

**Parameters:**

Name | Type |
------ | ------ |
`message` | [CoordinatorServerErrorMsg](#enumeration-coordinatorservererrormsg) |
`approvedOrders` | `SignedOrder`[] |
`cancellations` | [CoordinatorServerCancellationResponse](#interface-coordinatorservercancellationresponse)[] |
`errors` | [CoordinatorServerResponse](#interface-coordinatorserverresponse)[] |

**Returns:** *[CoordinatorServerError](#class-coordinatorservererror)*

## Properties

#### `Optional` approvedOrders

• **approvedOrders**? : *`SignedOrder`[]* =  []

*Defined in [utils/coordinator_server_types.ts:41](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L41)*

___

### `Optional` cancellations

• **cancellations**? : *[CoordinatorServerCancellationResponse](#interface-coordinatorservercancellationresponse)[]* =  []

*Defined in [utils/coordinator_server_types.ts:42](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L42)*

___

###  errors

• **errors**: *[CoordinatorServerResponse](#interface-coordinatorserverresponse)[]*

*Defined in [utils/coordinator_server_types.ts:43](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L43)*

___

###  message

• **message**: *[CoordinatorServerErrorMsg](#enumeration-coordinatorservererrormsg)*

*Overrides void*

*Defined in [utils/coordinator_server_types.ts:40](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L40)*

___

###  name

• **name**: *string*





___

### `Optional` stack

• **stack**? : *undefined | string*



*Overrides void*



___

### `Static` Error

▪ **Error**: *`ErrorConstructor`*



<hr />

# Enumeration: ContractError


##  Enumeration members

###  ContractNotDeployedOnNetwork

• **ContractNotDeployedOnNetwork**: = "CONTRACT_NOT_DEPLOYED_ON_NETWORK"

*Defined in [types.ts:32](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L32)*

___

###  ERC721NoApproval

• **ERC721NoApproval**: = "ERC_721_NO_APPROVAL"

*Defined in [types.ts:42](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L42)*

___

###  ERC721OwnerNotFound

• **ERC721OwnerNotFound**: = "ERC_721_OWNER_NOT_FOUND"

*Defined in [types.ts:41](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L41)*

___

###  InsufficientAllowanceForTransfer

• **InsufficientAllowanceForTransfer**: = "INSUFFICIENT_ALLOWANCE_FOR_TRANSFER"

*Defined in [types.ts:33](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L33)*

___

###  InsufficientBalanceForTransfer

• **InsufficientBalanceForTransfer**: = "INSUFFICIENT_BALANCE_FOR_TRANSFER"

*Defined in [types.ts:34](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L34)*

___

###  InsufficientEthBalanceForDeposit

• **InsufficientEthBalanceForDeposit**: = "INSUFFICIENT_ETH_BALANCE_FOR_DEPOSIT"

*Defined in [types.ts:35](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L35)*

___

###  InsufficientWEthBalanceForWithdrawal

• **InsufficientWEthBalanceForWithdrawal**: = "INSUFFICIENT_WETH_BALANCE_FOR_WITHDRAWAL"

*Defined in [types.ts:36](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L36)*

___

###  InvalidJump

• **InvalidJump**: = "INVALID_JUMP"

*Defined in [types.ts:37](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L37)*

___

###  OutOfGas

• **OutOfGas**: = "OUT_OF_GAS"

*Defined in [types.ts:38](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L38)*

___

###  SignatureRequestDenied

• **SignatureRequestDenied**: = "SIGNATURE_REQUEST_DENIED"

*Defined in [types.ts:43](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L43)*

___

###  SubscriptionAlreadyPresent

• **SubscriptionAlreadyPresent**: = "SUBSCRIPTION_ALREADY_PRESENT"

*Defined in [types.ts:40](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L40)*

___

###  SubscriptionNotFound

• **SubscriptionNotFound**: = "SUBSCRIPTION_NOT_FOUND"

*Defined in [types.ts:39](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L39)*

<hr />

# Enumeration: ForwarderError


##  Enumeration members

###  CompleteFillFailed

• **CompleteFillFailed**: = "COMPLETE_FILL_FAILED"

*Defined in [types.ts:28](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L28)*

<hr />

# Enumeration: OrderStatus


##  Enumeration members

###  Cancelled

• **Cancelled**:

*Defined in [types.ts:91](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L91)*

___

###  Expired

• **Expired**:

*Defined in [types.ts:89](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L89)*

___

###  Fillable

• **Fillable**:

*Defined in [types.ts:88](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L88)*

___

###  FullyFilled

• **FullyFilled**:

*Defined in [types.ts:90](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L90)*

___

###  Invalid

• **Invalid**: = 0

*Defined in [types.ts:85](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L85)*

___

###  InvalidMakerAssetAmount

• **InvalidMakerAssetAmount**:

*Defined in [types.ts:86](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L86)*

___

###  InvalidTakerAssetAmount

• **InvalidTakerAssetAmount**:

*Defined in [types.ts:87](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L87)*

<hr />

# Enumeration: CoordinatorServerErrorMsg


##  Enumeration members

###  CancellationFailed

• **CancellationFailed**: = "Failed to cancel with some coordinator server(s). See errors for more info. See cancellations for successful cancellations."

*Defined in [utils/coordinator_server_types.ts:59](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L59)*

___

###  FillFailed

• **FillFailed**: = "Failed to obtain approval signatures from some coordinator server(s). See errors for more info. Current transaction has been abandoned but you may resubmit with only approvedOrders (a new ZeroEx transaction will have to be signed)."

*Defined in [utils/coordinator_server_types.ts:60](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L60)*

<hr />

# Enumeration: ContractError


##  Enumeration members

###  ContractNotDeployedOnNetwork

• **ContractNotDeployedOnNetwork**: = "CONTRACT_NOT_DEPLOYED_ON_NETWORK"

*Defined in [utils/decorators.ts:4](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L4)*

___

###  ERC721NoApproval

• **ERC721NoApproval**: = "ERC_721_NO_APPROVAL"

*Defined in [utils/decorators.ts:14](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L14)*

___

###  ERC721OwnerNotFound

• **ERC721OwnerNotFound**: = "ERC_721_OWNER_NOT_FOUND"

*Defined in [utils/decorators.ts:13](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L13)*

___

###  InsufficientAllowanceForTransfer

• **InsufficientAllowanceForTransfer**: = "INSUFFICIENT_ALLOWANCE_FOR_TRANSFER"

*Defined in [utils/decorators.ts:5](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L5)*

___

###  InsufficientBalanceForTransfer

• **InsufficientBalanceForTransfer**: = "INSUFFICIENT_BALANCE_FOR_TRANSFER"

*Defined in [utils/decorators.ts:6](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L6)*

___

###  InsufficientEthBalanceForDeposit

• **InsufficientEthBalanceForDeposit**: = "INSUFFICIENT_ETH_BALANCE_FOR_DEPOSIT"

*Defined in [utils/decorators.ts:7](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L7)*

___

###  InsufficientWEthBalanceForWithdrawal

• **InsufficientWEthBalanceForWithdrawal**: = "INSUFFICIENT_WETH_BALANCE_FOR_WITHDRAWAL"

*Defined in [utils/decorators.ts:8](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L8)*

___

###  InvalidJump

• **InvalidJump**: = "INVALID_JUMP"

*Defined in [utils/decorators.ts:9](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L9)*

___

###  OutOfGas

• **OutOfGas**: = "OUT_OF_GAS"

*Defined in [utils/decorators.ts:10](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L10)*

___

###  SignatureRequestDenied

• **SignatureRequestDenied**: = "SIGNATURE_REQUEST_DENIED"

*Defined in [utils/decorators.ts:15](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L15)*

___

###  SubscriptionAlreadyPresent

• **SubscriptionAlreadyPresent**: = "SUBSCRIPTION_ALREADY_PRESENT"

*Defined in [utils/decorators.ts:12](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L12)*

___

###  SubscriptionNotFound

• **SubscriptionNotFound**: = "SUBSCRIPTION_NOT_FOUND"

*Defined in [utils/decorators.ts:11](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L11)*

<hr />




##  Functions

###  getAbiEncodedTransactionData

▸ **getAbiEncodedTransactionData**<**K**>(`contractInstance`: `ExchangeContract`, `methodName`: `K`, ...`params`: any[]): *string*

*Defined in [utils/getAbiEncodedTransactionData.ts:8](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/getAbiEncodedTransactionData.ts#L8)*

Returns the ABI encoded transaction hash for a given method and arguments

**Type parameters:**

▪ **K**: *keyof ExchangeContract*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`contractInstance` | `ExchangeContract` | - |
`methodName` | `K` | Must be a valid name of a function in the Solidity Exchange Contract |
`...params` | any[] | The appropriate arguments for the method given, in order  |

**Returns:** *string*

<hr />

# Interface: ContractWrappersConfig

networkId: The id of the underlying ethereum network your provider is connected to. (1-mainnet, 3-ropsten, 4-rinkeby, 42-kovan, 50-testrpc)
gasPrice: Gas price to use with every transaction
contractAddresses: The address of all contracts to use. Defaults to the known addresses based on networkId.
blockPollingIntervalMs: The interval to use for block polling in event watching methods (defaults to 1000)


##   Properties

### `Optional` blockPollingIntervalMs

• **blockPollingIntervalMs**? : *undefined | number*

*Defined in [types.ts:56](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L56)*

___

### `Optional` contractAddresses

• **contractAddresses**? : *`ContractAddresses`*

*Defined in [types.ts:55](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L55)*

___

### `Optional` gasPrice

• **gasPrice**? : *`BigNumber`*

*Defined in [types.ts:54](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L54)*

___

###  networkId

• **networkId**: *number*

*Defined in [types.ts:53](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L53)*

<hr />



# Interface: DecodedLogEvent <**ArgsType**>

## Type parameters

▪ **ArgsType**: *`DecodedLogArgs`*


##   Properties

###  isRemoved

• **isRemoved**: *boolean*

*Defined in [types.ts:7](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L7)*

___

###  log

• **log**: *`LogWithDecodedArgs<ArgsType>`*

*Defined in [types.ts:8](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L8)*

<hr />

# Interface: IndexedFilterValues


##  Hierarchy

* **OrderAndTraderInfo**


##  Properties

###  orderInfo

• **orderInfo**: *[OrderInfo](#interface-orderinfo)*

*Defined in [types.ts:106](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L106)*

___

###  traderInfo

• **traderInfo**: *[TraderInfo](#interface-traderinfo)*

*Defined in [types.ts:107](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L107)*

<hr />

# Interface: OrderInfo


##   Properties

###  orderHash

• **orderHash**: *string*

*Defined in [types.ts:80](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L80)*

___

###  orderStatus

• **orderStatus**: *[OrderStatus](#enumeration-orderstatus)*

*Defined in [types.ts:79](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L79)*

___

###  orderTakerAssetFilledAmount

• **orderTakerAssetFilledAmount**: *`BigNumber`*

*Defined in [types.ts:81](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L81)*

<hr />

# Interface: OrderTransactionOpts

shouldValidate: Flag indicating whether the library should make attempts to validate a transaction before
broadcasting it. For example, order has a valid signature, maker has sufficient funds, etc. Default=true.


##   Properties

### `Optional` gasLimit

• **gasLimit**? : *undefined | number*

*Inherited from [TransactionOpts](#interface-transactionopts).[gasLimit](#optional-gaslimit)*

*Defined in [types.ts:66](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L66)*

___

### `Optional` gasPrice

• **gasPrice**? : *`BigNumber`*

*Inherited from [TransactionOpts](#interface-transactionopts).[gasPrice](#optional-gasprice)*

*Defined in [types.ts:65](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L65)*

___

### `Optional` nonce

• **nonce**? : *undefined | number*

*Inherited from [TransactionOpts](#interface-transactionopts).[nonce](#optional-nonce)*

*Defined in [types.ts:67](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L67)*

___

### `Optional` shouldValidate

• **shouldValidate**? : *undefined | false | true*

*Defined in [types.ts:75](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L75)*

<hr />





# Class: ContractWrappers

The ContractWrappers class contains smart contract wrappers helpful when building on 0x protocol.


##   Constructors



\+ **new ContractWrappers**(`supportedProvider`: `SupportedProvider`, `config`: [ContractWrappersConfig](#interface-contractwrappersconfig)): *[ContractWrappers](#class-contractwrappers)*

*Defined in [contract_wrappers.ts:84](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L84)*

Instantiates a new ContractWrappers instance.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | `SupportedProvider` | The Provider instance you would like the contract-wrappers library to use for interacting with                      the Ethereum network. |
`config` | [ContractWrappersConfig](#interface-contractwrappersconfig) | The configuration object. Look up the type for the description. |

**Returns:** *[ContractWrappers](#class-contractwrappers)*

An instance of the ContractWrappers class.

## Properties

###  contractAddresses

• **contractAddresses**: *`ContractAddresses`*

*Defined in [contract_wrappers.ts:43](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L43)*

An index of the default contract addresses for this network.

___

###  coordinator

• **coordinator**: *[CoordinatorWrapper](#class-coordinatorwrapper)*

*Defined in [contract_wrappers.ts:82](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L82)*

An instance of the CoordinatorWrapper class containing methods for interacting with the Coordinator extension contract.

___

###  devUtils

• **devUtils**: *`DevUtilsContract`*

*Defined in [contract_wrappers.ts:78](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L78)*

An instance of the DevUtilsContract class containing methods for interacting with the DevUtils smart contract.

___

###  dutchAuction

• **dutchAuction**: *`DutchAuctionContract`*

*Defined in [contract_wrappers.ts:74](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L74)*

An instance of the DutchAuctionContract class containing methods for interacting with any DutchAuction smart contract.

___

###  erc20Proxy

• **erc20Proxy**: *`ERC20ProxyContract`*

*Defined in [contract_wrappers.ts:52](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L52)*

An instance of the ERC20ProxyContract class containing methods for interacting with the
erc20Proxy smart contract.

___

###  erc721Proxy

• **erc721Proxy**: *`ERC721ProxyContract`*

*Defined in [contract_wrappers.ts:57](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L57)*

An instance of the ERC721ProxyContract class containing methods for interacting with the
erc721Proxy smart contract.

___

###  exchange

• **exchange**: *`ExchangeContract`*

*Defined in [contract_wrappers.ts:47](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L47)*

An instance of the ExchangeContract class containing methods for interacting with the 0x Exchange smart contract.

___

###  forwarder

• **forwarder**: *`ForwarderContract`*

*Defined in [contract_wrappers.ts:66](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L66)*

An instance of the ForwarderContract class containing methods for interacting with any Forwarder smart contract.

___

###  orderValidator

• **orderValidator**: *`OrderValidatorContract`*

*Defined in [contract_wrappers.ts:70](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L70)*

An instance of the OrderValidatorContract class containing methods for interacting with any OrderValidator smart contract.

___

###  weth9

• **weth9**: *`WETH9Contract`*

*Defined in [contract_wrappers.ts:62](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L62)*

An instance of the WETH9Contract class containing methods for interacting with the
WETH9 smart contract.

## Methods

###  getAbiDecoder

▸ **getAbiDecoder**(): *`AbiDecoder`*

*Defined in [contract_wrappers.ts:155](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L155)*

Get the abi decoder instance currently used by contract-wrappers

**Returns:** *`AbiDecoder`*

AbiDecoder instance

___

###  getProvider

▸ **getProvider**(): *`SupportedProvider`*

*Defined in [contract_wrappers.ts:148](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L148)*

Get the provider instance currently used by contract-wrappers

**Returns:** *`SupportedProvider`*

Web3 provider instance

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [contract_wrappers.ts:138](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/contract_wrappers.ts#L138)*

Unsubscribes from all subscriptions for all contracts.

**Returns:** *void*

<hr />

# Interface: CoordinatorOutstandingFillSignatures


##   Properties

###  approvalSignatures

• **approvalSignatures**: *string[]*

*Defined in [utils/coordinator_server_types.ts:19](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L19)*

___

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`*

*Defined in [utils/coordinator_server_types.ts:20](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L20)*

___

###  orderHash

• **orderHash**: *string*

*Defined in [utils/coordinator_server_types.ts:18](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L18)*

___

###  takerAssetFillAmount

• **takerAssetFillAmount**: *`BigNumber`*

*Defined in [utils/coordinator_server_types.ts:21](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L21)*

<hr />

# Interface: CoordinatorServerApprovalRawResponse


##   Properties

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`*

*Defined in [utils/coordinator_server_types.ts:10](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L10)*

___

###  signatures

• **signatures**: *string[]*

*Defined in [utils/coordinator_server_types.ts:9](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L9)*

<hr />

# Interface: CoordinatorServerApprovalResponse


##   Properties

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`[]*

*Defined in [utils/coordinator_server_types.ts:6](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L6)*

___

###  signatures

• **signatures**: *string[]*

*Defined in [utils/coordinator_server_types.ts:5](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L5)*

<hr />

# Interface: CoordinatorServerCancellationResponse


##   Properties

###  cancellationSignatures

• **cancellationSignatures**: *string[]*

*Defined in [utils/coordinator_server_types.ts:15](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L15)*

___

###  outstandingFillSignatures

• **outstandingFillSignatures**: *[CoordinatorOutstandingFillSignatures](#class-coordinatoroutstandingfillsignatures)[]*

*Defined in [utils/coordinator_server_types.ts:14](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L14)*

<hr />

# Interface: CoordinatorServerRequest


##   Properties

###  signedTransaction

• **signedTransaction**: *`SignedZeroExTransaction`*

*Defined in [utils/coordinator_server_types.ts:35](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L35)*

___

###  txOrigin

• **txOrigin**: *string*

*Defined in [utils/coordinator_server_types.ts:36](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L36)*

<hr />

# Interface: CoordinatorServerResponse


##   Properties

### `Optional` body

• **body**? : *[CoordinatorServerCancellationResponse](_utils_coordinator_server_types_.coordinatorservercancellationresponse.md) | [CoordinatorServerApprovalRawResponse](#class-coordinatorserverapprovalrawresponse)*

*Defined in [utils/coordinator_server_types.ts:27](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L27)*

___

###  coordinatorOperator

• **coordinatorOperator**: *string*

*Defined in [utils/coordinator_server_types.ts:30](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L30)*

___

### `Optional` error

• **error**? : *any*

*Defined in [utils/coordinator_server_types.ts:28](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L28)*

___

###  isError

• **isError**: *boolean*

*Defined in [utils/coordinator_server_types.ts:25](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L25)*

___

### `Optional` orders

• **orders**? : *`Array<SignedOrder | Order>`*

*Defined in [utils/coordinator_server_types.ts:31](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L31)*

___

###  request

• **request**: *[CoordinatorServerRequest](#class-coordinatorserverrequest)*

*Defined in [utils/coordinator_server_types.ts:29](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L29)*

___

###  status

• **status**: *number*

*Defined in [utils/coordinator_server_types.ts:26](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/coordinator_server_types.ts#L26)*

<hr />




##  Type aliases

###  AsyncMethod

Ƭ **AsyncMethod**: *function*

*Defined in [utils/decorators.ts:18](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L18)*

#### Type declaration:

▸ (...`args`: any[]): *`Promise<any>`*

**Parameters:**

Name | Type |
------ | ------ |
`...args` | any[] |

___

###  SyncMethod

Ƭ **SyncMethod**: *function*

*Defined in [utils/decorators.ts:19](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L19)*

#### Type declaration:

▸ (...`args`: any[]): *any*

**Parameters:**

Name | Type |
------ | ------ |
`...args` | any[] |

## Object literals

### `Const` decorators

#### ▪ **decorators**: *object*

*Defined in [utils/decorators.ts:130](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L130)*

####  asyncZeroExErrorHandler

• **asyncZeroExErrorHandler**: *`asyncErrorHandlingDecorator`* =  asyncErrorHandlerFactory(zeroExErrorTransformer)

*Defined in [utils/decorators.ts:131](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L131)*

####  syncZeroExErrorHandler

• **syncZeroExErrorHandler**: *`syncErrorHandlingDecorator`* =  syncErrorHandlerFactory(zeroExErrorTransformer)

*Defined in [utils/decorators.ts:132](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/decorators.ts#L132)*

<hr />



<hr /> 



<hr /> 



<hr /> 



<hr />




##  Object literals

#### `Const` ContractWrappersConfigSchema

#### ▪ **ContractWrappersConfigSchema**: *object*

*Defined in [schemas/contract_wrappers_config_schema.ts:1](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/contract_wrappers_config_schema.ts#L1)*

####  id

• **id**: *string* = "/ContractWrappersConfig"

*Defined in [schemas/contract_wrappers_config_schema.ts:2](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/contract_wrappers_config_schema.ts#L2)*

####  required

• **required**: *string[]* =  ['networkId']

*Defined in [schemas/contract_wrappers_config_schema.ts:24](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/contract_wrappers_config_schema.ts#L24)*

####  type

• **type**: *string* = "object"

*Defined in [schemas/contract_wrappers_config_schema.ts:23](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/contract_wrappers_config_schema.ts#L23)*

▪ **properties**: *object*

*Defined in [schemas/contract_wrappers_config_schema.ts:3](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/contract_wrappers_config_schema.ts#L3)*

* **blockPollingIntervalMs**: *object*

  * **type**: *string* = "number"

* **contractAddresses**: *object*

  * **type**: *string* = "object"

  * **properties**: *object*

    * **assetProxyOwner**: *object*

      * **$ref**: *string* = "/addressSchema"

    * **erc20Proxy**: *object*

      * **$ref**: *string* = "/addressSchema"

    * **erc721Proxy**: *object*

      * **$ref**: *string* = "/addressSchema"

    * **etherToken**: *object*

      * **$ref**: *string* = "/addressSchema"

    * **exchange**: *object*

      * **$ref**: *string* = "/addressSchema"

    * **forwarder**: *object*

      * **$ref**: *string* = "/addressSchema"

    * **orderValidator**: *object*

      * **$ref**: *string* = "/addressSchema"

    * **zrxToken**: *object*

      * **$ref**: *string* = "/addressSchema"

* **gasPrice**: *object*

  * **$ref**: *string* = "/numberSchema"

* **networkId**: *object*

  * **type**: *string* = "number"

<hr />




##  Object literals

#### `Const` orderTxOptsSchema

#### ▪ **orderTxOptsSchema**: *object*

*Defined in [schemas/order_tx_opts_schema.ts:1](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/order_tx_opts_schema.ts#L1)*

####  allOf

• **allOf**: *object[]* =  [{ $ref: '/TxOpts' }]

*Defined in [schemas/order_tx_opts_schema.ts:3](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/order_tx_opts_schema.ts#L3)*

####  id

• **id**: *string* = "/OrderTxOpts"

*Defined in [schemas/order_tx_opts_schema.ts:2](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/order_tx_opts_schema.ts#L2)*

####  type

• **type**: *string* = "object"

*Defined in [schemas/order_tx_opts_schema.ts:7](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/order_tx_opts_schema.ts#L7)*

▪ **properties**: *object*

*Defined in [schemas/order_tx_opts_schema.ts:4](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/order_tx_opts_schema.ts#L4)*

* **shouldValidate**: *object*

  * **type**: *string* = "boolean"

<hr />




##  Object literals

#### `Const` txOptsSchema

#### ▪ **txOptsSchema**: *object*

*Defined in [schemas/tx_opts_schema.ts:1](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/tx_opts_schema.ts#L1)*

####  id

• **id**: *string* = "/TxOpts"

*Defined in [schemas/tx_opts_schema.ts:2](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/tx_opts_schema.ts#L2)*

####  type

• **type**: *string* = "object"

*Defined in [schemas/tx_opts_schema.ts:8](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/tx_opts_schema.ts#L8)*

▪ **properties**: *object*

*Defined in [schemas/tx_opts_schema.ts:3](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/schemas/tx_opts_schema.ts#L3)*

* **gasLimit**: *object*

  * **type**: *string* = "number"

* **gasPrice**: *object*

  * **$ref**: *string* = "/numberSchema"

* **nonce**: *object*

  * **type**: *string* = "number"

<hr />




##  Type aliases

####  EventCallback

Ƭ **EventCallback**: *function*

*Defined in [types.ts:11](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/types.ts#L11)*

##### Type declaration:

▸ (`err`: null | `Error`, `log?`: [DecodedLogEvent](#interface-decodedlogevent)‹*`ArgsType`*›): *void*

**Parameters:**

Name | Type |
------ | ------ |
`err` | null \| `Error` |
`log?` | [DecodedLogEvent](#interface-decodedlogevent)‹*`ArgsType`*› |

<hr />




##  Object literals

#### `Const` assert

#### ▪ **assert**: *object*

*Defined in [utils/assert.ts:13](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L13)*

####  allMakerAssetDatasAreErc20Token

▸ **allMakerAssetDatasAreErc20Token**(`orders`: `Order`[], `tokenAddress`: string): *void*

*Defined in [utils/assert.ts:61](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L61)*

**Parameters:**

Name | Type |
------ | ------ |
`orders` | `Order`[] |
`tokenAddress` | string |

**Returns:** *void*

####  allTakerAddressesAreNull

▸ **allTakerAddressesAreNull**(`orders`: `Order`[]): *void*

*Defined in [utils/assert.ts:58](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L58)*

**Parameters:**

Name | Type |
------ | ------ |
`orders` | `Order`[] |

**Returns:** *void*

####  allTakerAssetDatasAreErc20Token

▸ **allTakerAssetDatasAreErc20Token**(`orders`: `Order`[], `tokenAddress`: string): *void*

*Defined in [utils/assert.ts:68](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L68)*

**Parameters:**

Name | Type |
------ | ------ |
`orders` | `Order`[] |
`tokenAddress` | string |

**Returns:** *void*

####  feeOrdersCanBeUsedForForwarderContract

▸ **feeOrdersCanBeUsedForForwarderContract**(`orders`: `Order`[], `zrxTokenAddress`: string, `etherTokenAddress`: string): *void*

*Defined in [utils/assert.ts:52](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L52)*

**Parameters:**

Name | Type |
------ | ------ |
`orders` | `Order`[] |
`zrxTokenAddress` | string |
`etherTokenAddress` | string |

**Returns:** *void*

####  isSenderAddressAsync

▸ **isSenderAddressAsync**(`variableName`: string, `senderAddressHex`: string, `web3Wrapper`: `Web3Wrapper`): *`Promise<void>`*

*Defined in [utils/assert.ts:34](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L34)*

**Parameters:**

Name | Type |
------ | ------ |
`variableName` | string |
`senderAddressHex` | string |
`web3Wrapper` | `Web3Wrapper` |

**Returns:** *`Promise<void>`*

####  isValidSignatureAsync

▸ **isValidSignatureAsync**(`supportedProvider`: `SupportedProvider`, `orderHash`: string, `signature`: string, `signerAddress`: string): *`Promise<void>`*

*Defined in [utils/assert.ts:15](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L15)*

**Parameters:**

Name | Type |
------ | ------ |
`supportedProvider` | `SupportedProvider` |
`orderHash` | string |
`signature` | string |
`signerAddress` | string |

**Returns:** *`Promise<void>`*

####  isValidSubscriptionToken

▸ **isValidSubscriptionToken**(`variableName`: string, `subscriptionToken`: string): *void*

*Defined in [utils/assert.ts:29](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L29)*

**Parameters:**

Name | Type |
------ | ------ |
`variableName` | string |
`subscriptionToken` | string |

**Returns:** *void*

####  ordersCanBeUsedForForwarderContract

▸ **ordersCanBeUsedForForwarderContract**(`orders`: `Order`[], `etherTokenAddress`: string): *void*

*Defined in [utils/assert.ts:46](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L46)*

**Parameters:**

Name | Type |
------ | ------ |
`orders` | `Order`[] |
`etherTokenAddress` | string |

**Returns:** *void*

####  ordersHaveAtMostOneUniqueValueForProperty

▸ **ordersHaveAtMostOneUniqueValueForProperty**(`orders`: `Order`[], `propertyName`: string, `value?`: any): *void*

*Defined in [utils/assert.ts:79](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/assert.ts#L79)*

**Parameters:**

Name | Type |
------ | ------ |
`orders` | `Order`[] |
`propertyName` | string |
`value?` | any |

**Returns:** *void*

<hr />




##  Functions

####  _getDefaultContractAddresses

▸ **_getDefaultContractAddresses**(`networkId`: number): *`ContractAddresses`*

*Defined in [utils/contract_addresses.ts:8](https://github.com/0xProject/0x-monorepo/blob/23602ec6b/packages/contract-wrappers/src/utils/contract_addresses.ts#L8)*

Returns the default contract addresses for the given networkId or throws with
a context-specific error message if the networkId is not recognized.

**Parameters:**

Name | Type |
------ | ------ |
`networkId` | number |

**Returns:** *`ContractAddresses`*

<hr />



<hr /> 

